local FRACUNIT = FRACUNIT
local TICRATE = TICRATE
freeslot("MT_TAGTEAMFX")

for i = 1, 6 do
	freeslot("S_TAGTEAMFX"..i)
end

states[S_TAGTEAMFX1] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = A,
	nextstate = S_TAGTEAMFX2
}

states[S_TAGTEAMFX2] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = B,
	nextstate = S_TAGTEAMFX3
}

states[S_TAGTEAMFX3] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = C,
	nextstate = S_TAGTEAMFX4
}

states[S_TAGTEAMFX4] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = D,
	nextstate = S_TAGTEAMFX5
}

states[S_TAGTEAMFX5] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = E,
	nextstate = S_TAGTEAMFX6
}

states[S_TAGTEAMFX6] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = F,

}

mobjinfo[MT_TAGTEAMFX] = {
	spawnstate = S_TAGTEAMFX1,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT
}

local function TT_TagIn (p)
	if (HOSTMOD and CV_FindVar("hm_restat").value and p.HMRs) then
		if p.mo.skin == "pyraaegis" then
			p.mo.skin = "mythraaegis"
			p.kartspeed = 10 - p.kartspeed
			p.kartweight = 10 - p.kartweight
			/*
			if p.mo.color == SKINCOLOR_RASPBERRY then
				p.mo.color = SKINCOLOR_WHITE
			else
				p.mo.color = ColorOpposite($)
			end
			*/
		elseif p.mo.skin == "mythraaegis" then
			p.mo.skin = "pyraaegis"
			p.kartspeed = 10 - p.kartspeed
			p.kartweight = 10 - p.kartweight
			/*
			if p.mo.color == SKINCOLOR_WHITE then
				p.mo.color = SKINCOLOR_RASPBERRY
			else
				p.mo.color = ColorOpposite($)
			end
			*/
		end
	else
		if p.mo.skin == "pyraaegis" then
			p.mo.skin = "mythraaegis"
			p.kartspeed = skins["mythraaegis"].kartspeed
			p.kartweight = skins["mythraaegis"].kartweight
			/*
			if p.mo.color == SKINCOLOR_RASPBERRY then
				p.mo.color = SKINCOLOR_WHITE
			else
				p.mo.color = ColorOpposite($)
			end
			*/
		elseif p.mo.skin == "mythraaegis" then
			p.mo.skin = "pyraaegis"
			p.kartspeed = skins["pyraaegis"].kartspeed
			p.kartweight = skins["pyraaegis"].kartweight
			/*
			if p.mo.color == SKINCOLOR_WHITE then
				p.mo.color = SKINCOLOR_RASPBERRY
			else
				p.mo.color = ColorOpposite($)
			end
			*/
		end
	end
	
	p.kartstuff[k_driftcharge] = 0
	local transform = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_TAGTEAMFX)
	transform.angle = p.mo.angle
	S_StartSound(p.mo, sfx_supert)
	K_PlayBoostTaunt(p.mo)
	p.TTcooldown = 2*TICRATE
end

local function TT_CooldownHandler(p)
	p.TTcooldown = max($-1, 0)
	
	if p.TTcooldown then
		p.mo.colorized = true
	end
end

local function TT_CanTag(p)
	return not (	p.TTcooldown > 0
				or 	p.kartstuff[k_spinouttimer] > 0
				or 	p.kartstuff[k_squishedtimer] > 0
				or 	p.playerstate ~= PST_LIVE
				or not P_IsObjectOnGround(p.mo)
				or p.kartstuff[k_itemtype])
end

local function TT_TagInputs(p)
	p.TTinputbuffer = max($ - 1, 0)
	
	if (p.cmd.buttons & BT_ATTACK and not p.TTlastitempress) then
		p.TTinputbuffer = TICRATE/3
	end
end

local function TagTeam(p)
	if not (skins["pyraaegis"] and skins["mythraaegis"]) then return end
	if not (p.mo.skin == "pyraaegis" or p.mo.skin == "mythraaegis") then return end
	if leveltime < 236 then return end
	TT_CooldownHandler(p)
	TT_TagInputs(p)
	
	if (p.cmd.buttons & BT_ATTACK and not p.TTlastitempress)
	and (p.TTinputbuffer and p.TTlastbuffer)
	and TT_CanTag(p) then
		TT_TagIn(p)
	end
	
	p.TTlastbuffer = p.TTinputbuffer
	p.TTlastitem = p.kartstuff[k_itemtype]
	p.TTlastitempress = p.cmd.buttons & BT_ATTACK and not p.TTlastitem
end

addHook("PlayerThink", TagTeam)

addHook("PlayerSpawn", function(p)
	p.TTcooldown = 0
	p.TTinputbuffer = 0
	p.TTlastbuffer = 0
	p.TTlastitem = 0
	p.TTlastitempress = 0
end)